/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/* dasum.f -- translated by f2c (version 19980913).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

doublereal dasum_ (n, dx, incx)
     integer *n;
     doublereal *dx;
     integer *incx;
{
   /* System generated locals */
   integer i__1, i__2;
   doublereal ret_val, d__1, d__2, d__3, d__4, d__5, d__6;

   /* Local variables */
   static integer i__, m, ns, mp1;

/* ***BEGIN PROLOGUE  DASUM */
/* ***DATE WRITTEN   791001   (YYMMDD) */
/* ***REVISION DATE  820801   (YYMMDD) */
/* ***CATEGORY NO.  D1A3A */
/* ***KEYWORDS  ADD,BLAS,DOUBLE PRECISION,LINEAR ALGEBRA,MAGNITUDE,SUM, */
/*             VECTOR */
/* ***AUTHOR  LAWSON, C. L., (JPL) */
/*           HANSON, R. J., (SNLA) */
/*           KINCAID, D. R., (U. OF TEXAS) */
/*           KROGH, F. T., (JPL) */
/* ***PURPOSE  Sum of magnitudes of d.p. vector components */
/* ***DESCRIPTION */

/*                B L A S  Subprogram */
/*    Description of Parameters */

/*     --Input-- */
/*        N  number of elements in input vector(s) */
/*       DX  double precision vector with N elements */
/*     INCX  storage spacing between elements of DX */

/*     --Output-- */
/*    DASUM  double precision result (zero if N .LE. 0) */

/*     Returns sum of magnitudes of double precision DX. */
/*     DASUM = sum from 0 to N-1 of DABS(DX(1+I*INCX)) */
/* ***REFERENCES  LAWSON C.L., HANSON R.J., KINCAID D.R., KROGH F.T., */
/*                 *BASIC LINEAR ALGEBRA SUBPROGRAMS FOR FORTRAN USAGE*, */
/*                 ALGORITHM NO. 539, TRANSACTIONS ON MATHEMATICAL */
/*                 SOFTWARE, VOLUME 5, NUMBER 3, SEPTEMBER 1979, 308-323 */
/* ***ROUTINES CALLED  (NONE) */
/* ***END PROLOGUE  DASUM */

/* ***FIRST EXECUTABLE STATEMENT  DASUM */
   /* Parameter adjustments */
   --dx;

   /* Function Body */
   ret_val = 0.;
   if (*n <= 0)
   {
      return ret_val;
   }
   if (*incx == 1)
   {
      goto L20;
   }

/*        CODE FOR INCREMENTS NOT EQUAL TO 1. */

   ns = *n * *incx;
   i__1 = ns;
   i__2 = *incx;
   for (i__ = 1; i__2 < 0 ? i__ >= i__1 : i__ <= i__1; i__ += i__2)
   {
      ret_val += (d__1 = dx[i__], abs (d__1));
/* L10: */
   }
   return ret_val;

/*        CODE FOR INCREMENTS EQUAL TO 1. */

/*        CLEAN-UP LOOP SO REMAINING VECTOR LENGTH IS A MULTIPLE OF 6. */

 L20:
   m = *n % 6;
   if (m == 0)
   {
      goto L40;
   }
   i__2 = m;
   for (i__ = 1; i__ <= i__2; ++i__)
   {
      ret_val += (d__1 = dx[i__], abs (d__1));
/* L30: */
   }
   if (*n < 6)
   {
      return ret_val;
   }
 L40:
   mp1 = m + 1;
   i__2 = *n;
   for (i__ = mp1; i__ <= i__2; i__ += 6)
   {
      ret_val = ret_val + (d__1 = dx[i__], abs (d__1)) + (d__2 = dx[i__ + 1],
                                                          abs (d__2)) + (d__3 =
                                                                         dx[i__
                                                                            +
                                                                            2],
                                                                         abs
                                                                         (d__3))
         + (d__4 = dx[i__ + 3], abs (d__4)) + (d__5 =
                                               dx[i__ + 4],
                                               abs (d__5)) + (d__6 =
                                                              dx[i__ + 5],
                                                              abs (d__6));
/* L50: */
   }
   return ret_val;
}                                       /* dasum_ */
