/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/*
 * header file for mixed model parts of linkage.
 * $Id: mixd.h,v 1.1 2007-07-18 04:48:39 myrna Exp $
 */

#ifndef MIXED_H
#define MIXED_H

#include "lsample.h"

/*
 * Sample the additive component, given the curent realization of genotype
 * and model.
 *
 * Side effects: ym and zadd updated.
 */
void smpl_a ( struct Locus *loci,
              int n_loci,
              double ve,
              double va,
              double mu,
              double mynp,
              double *zadd                   /* additive genetic variance */
              );

/*
 * sample additive genetic component
 *
 * Side efffects: zadd[i] updated.
 */
void cond_z ( int i,
              double y_mu,
              double ve,
              double va,
              double *zadd                   /* additive genetic variance */
              );

#endif                                       /* MIXED_H */
