#include "nghds.h"
/* Routine written to set sib links for linkage output */
/*            EAT  Feb 2009                            */

void setup_siblinks (int *redex)
/* re-index according to order of Marriage lists   */
{
   int   i1, i2, ik, sx, fstm, tot;
   int  *donedex;

   Indlist *pk, *pnk;
   Marlist *pm;
   Ind  *kid1, *kid2, *lstk;

   donedex = malloc (pedsize * sizeof (int));
   for (i1 = 0; i1 < pedsize; ++i1)
      donedex[i1] = 0;

   tot = 0;
   for (i1 = 0; i1 < pedsize; ++i1)
   {                                    /* go through everyone in the pedigree */
      if (donedex[i1] == 0)
      {
         redex[tot] = i1;
         donedex[i1] = 1;
         ++tot;
      }
      sx = nghd[i1].sex;
      fstm = 1;                         /* first marriage of i1  */
      lstk = &nullnode;                 /* reset last-kid indicator */
      pm = nghd[i1].marriages;          /* pointer to marriages of i1 */
      if (DebugNghds)
         printf ("\n chk; processing individual %d, name %s sex %d",
                 i1, nghd[i1].self, sx);
      fflush (stdout);
      while (pm)                        /* i1 has marriages */
      {
         i2 = pm->current->spouse->index; /* need spouse in index order */
         if (donedex[i2] == 0)
         {
            redex[tot] = i2;
            donedex[i2] = 1;
            ++tot;
         }
         pk = pm->current->kids;        /* ptr to kids in current marriage */
         while (pk)
         {
            kid1 = pk->current;
            i2 = kid1->index;           /* need kids in index order */
            if (donedex[i2] == 0)
            {
               redex[tot] = i2;
               donedex[i2] = 1;
               ++tot;
            }
            if (fstm)                   /* set first kid of i1 */
            {
               nghd[i1].first_kid = kid1;
               fstm = 0;
            }
            if (lstk)                   /* last kid of previous marriage */
            {
               ik = lstk->index;
               if (sx == MALE)
                  nghd[ik].next_patsib = kid1;
               else if (sx == FEMALE)
                  nghd[ik].next_matsib = kid1;
               lstk = &nullnode;        /* reset last-kid indicator */
            }
            if (pk->next)
            {
               pnk = pk->next;
               kid2 = pnk->current;
               ik = kid1->index;
               if (sx == MALE)
                  nghd[ik].next_patsib = kid2;
               else if (sx == FEMALE)
                  nghd[ik].next_matsib = kid2;
            }
            else
               lstk = kid1;             /* kid1 is last of current marriage */
            pk = pk->next;
         }
         pm = pm->next;
      }
      if (lstk)                         /* last kid of last marriage of i1 */
      {
         ik = lstk->index;
         if (sx == MALE)
            nghd[ik].next_patsib = &nullnode;
         else if (sx == FEMALE)
            nghd[ik].next_matsib = &nullnode;
      }
   }
   free (donedex);
   return;
}
