/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

#include "quant.h"

void cheigen (double **gmat, double *evec, int nn)
{
   int   i, j, jjj, ierr;
   int  *iv1;
   double *dummy, *rvec, *ivec, *zz, *fv1;

   jjj = 0;

   if (ChkEigC)
      printf ("\n Reduced G-matrix has dimension %d\n", nn);

   dummy = malloc (nn * nn * sizeof (double));
   alloc_chk (WHERE, dummy);
   rvec = malloc (nn * sizeof (double));
   alloc_chk (WHERE, rvec);
   ivec = malloc (nn * sizeof (double));
   alloc_chk (WHERE, ivec);
   zz = malloc (nn * nn * sizeof (double));
   alloc_chk (WHERE, zz);
   fv1 = malloc (nn * sizeof (double));
   alloc_chk (WHERE, fv1);
   iv1 = malloc (nn * sizeof (int));
   alloc_chk (WHERE, iv1);

   for (i = 1; i <= nn; ++i)
      for (j = 1; j <= nn; ++j)
         dummy[i + nn * j - nn - 1] = gmat[i][j];

   if (ChkEigC)
      printf (" about to call rg_()\n");

   rg_ (&nn, &nn, dummy, rvec, ivec, &jjj, zz, iv1, fv1, &ierr);

   if (ChkEigC)
      printf (" back out of rg_()\n");

   if (ierr)
      give_warn_where (WHERE, ERQ_rge, ierr);
   else if (ChkEigC)
      printf (" normal return from rg_() with ierr = %d\n\n", ierr);

   for (i = 1; i <= nn; ++i)
      evec[i] = rvec[i - 1];

   free ((void *) dummy);
   dummy = NULL;
   free ((void *) rvec);
   rvec = NULL;
   free ((void *) ivec);
   ivec = NULL;
   free ((void *) zz);
   zz = NULL;
   free ((void *) iv1);
   iv1 = NULL;
   free ((void *) fv1);
   fv1 = NULL;

   return;
}
