/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/*
 THIS WHOLE ROUTINE IS A BUG. 
 READ PARAMETERS FROM FILE "twoqtl_parm" 
 THIS NEED TO BE REPLACED BY PARAMETER STATEMENTS.
 PARAMETER STATEMENTS CALL set_twoqtl_parm_dbl, set_twoqtl_parm_int,
 and set_geno_means AS THIS FUNCTION DOES.

 void set_twoqtl_parm (void); 

 temporary subroutine for setting parameters of lm_twoqtl. 

 (1) no default values yet
 (2) covariate effects not considered
 (3) NIt from n_batch, batch_size, and ScorIt 
 (4) Later parameter statement overwrite previous for now

 PARAMETERS                   Parameter Statements                         
                         
  SigErr = X                   set residual variance X
  SigAdd = X                   set additive variance X
  ScorIt = I                   compute scores every I iterations

  n_qtl = I                    set QTL number I
 
  allele_freq_1 = X1           set QTL 1 allele frequencies X1, X2
  allele_freq_2 = X1           set QTL 2 allele frequencies X1, X2

  geno_means_1 = {X1, X2, X3}  set QTL 1 genotype means X1 X2 X3
  geno_means_2 = {X1, X2, X3}  set QTL 2 genotype means X1 X2 X3
 
  n_batch = I                  set batch number I
  batch_size = I               set batch size I
  
  fou_sum_MC = 0               use exact summation for founders
               1               use MC summation for founders

  n_fou_sum_MC = I             use I MC realizations for founders

  sim_freq_1 = X1              use QTL 1 sim. allele frequencies X1, X2
  sim_freq_2 = X1              use QTL 2 sim. allele frequencies X1, X2
 
  debug_level = I              set debug level I
  
  null_it     = I              evaluate null I times per evalution of  
                               alternative
			       
  seed = X1 X2                 set founder seeds X1 X2

 YJS Jul 1, 2005
 */
#include "twoqtl.h"

static int is_twoqtl_parm_int (char *key);
static int is_twoqtl_parm_dbl (char *key);

const char FILE_NAME[] = "twoqtl_parm";

void set_twoqtl_parm (void)
{
   FILE *par_file;
   char  line[50], key[30];
   int   scan_count, i, match;
   unsigned int cseed, tseed;

   double *get_dbl, *means;
   double dbl_1, dbl_2, dbl_3;
   double dbl[3];

   par_file = fopen (FILE_NAME, "r");
   if (par_file == NULL)
   {
      fprintf (stderr, "Error: cannot open %s\n", FILE_NAME);
      perror (FILE_NAME);
      exit (EXIT_FAILURE);
   }

   fprintf (stdout, "... set parameters for lm_twoqtl (TEMP) ...\n\n");

   while (fgets (line, sizeof (line), par_file) != NULL)
   {
      scan_count = sscanf (line, "%s %lf %lf %lf", key, &dbl_1, &dbl_2, &dbl_3);
      if (scan_count == 2)
      {
         if (is_twoqtl_parm_dbl (key) == 1)
         {
            set_twoqtl_parm_dbl (key, dbl_1);

            if (get_twoqtl_parm_dbl (key) == dbl_1)
               fprintf (stdout, " %s: %3.1f\n", key, dbl_1);
         }
         else if (is_twoqtl_parm_int (key) == 1)
         {
            set_twoqtl_parm_int (key, (int) dbl_1);

            if (get_twoqtl_parm_int (key) == (int) dbl_1)
               fprintf (stdout, " %s: %3d\n", key, (int) dbl_1);
         }
      }
      else if (scan_count == 3)         /* allele_freq and sim_freq */
      {
         set_twoqtl_parm_dbl (key, dbl_1);

         if (get_twoqtl_parm_dbl (key) == dbl_1)
            fprintf (stdout, " %s: %4.2f\n", key, dbl_1);
      }
      else if (scan_count == 4)         /* geno_means */
      {
         dbl[0] = dbl_1;
         dbl[1] = dbl_2;
         dbl[2] = dbl_3;

         set_geno_means (key, dbl);
         get_dbl = get_geno_means (key);

         match = 0;
         for (i = 0; i < 3; ++i)
            match += (get_dbl[i] == dbl[i]);
         if (match == 3)
            fprintf (stdout, " %s: %3.1f %3.1f %3.1f\n",
                     key, dbl_1, dbl_2, dbl_3);
      }
      else if (scan_count == 1)
      {
         scan_count = sscanf (line, "%s %x %x", key, &cseed, &tseed);

         if ((scan_count == 3) && (strncmp (key, "seed", 20) == 0))
         {
            setsd_alt (cseed, tseed);
            fprintf (stdout, " %s: %08x %08x\n", key, cseed, tseed);
         }
      }
   }

   if (ferror (par_file))
   {
      fprintf (stderr, "Error occurred while reading %s\n", FILE_NAME);
      exit (EXIT_FAILURE);
   }
   fclose (par_file);

   if (get_twoqtl_parm_int ("n_qtl") == 2)
   {
      (void) get_twoqtl_parm_dbl ("allele_freq_2");
      /*      (void) get_geno_means ("geno_means_2"); *//* TEMP */
   }
   if (get_twoqtl_parm_int ("fou_sum_MC") == 1)
   {
      (void) get_twoqtl_parm_int ("n_fou_sum_MC");

      (void) get_twoqtl_parm_dbl ("sim_freq_1");
      if (get_twoqtl_parm_int ("n_qtl") == 2)
         (void) get_twoqtl_parm_dbl ("sim_freq_2");
   }
   (void) get_twoqtl_parm_int ("n_batch");
   (void) get_twoqtl_parm_int ("null_it");

   (void) get_twoqtl_parm_int ("debug_level");

   fprintf (stdout, " SigErr: %3.2f\n", get_twoqtl_parm_dbl ("SigErr"));
   fprintf (stdout, " SigAdd: %3.2f\n", get_twoqtl_parm_dbl ("SigAdd"));
   means = get_geno_means ("geno_means_1");
   fprintf (stdout, " geno_means_1 %4.2f %4.2f %4.2f\n",
            means[0], means[1], means[2]);

   if (get_twoqtl_parm_int ("ScorIt") == -1)
      set_twoqtl_parm_int ("ScorIt", ScorIt); /* GLOBAL ScorIt */

   fprintf (stdout, " ScorIt: %d\n", get_twoqtl_parm_int ("ScorIt"));

   fprintf (stdout, "\n... parameter setting for lm_twoqtl done (TEMP) ...\n");

   return;
}

int is_twoqtl_parm_dbl (char *key)
{
   if (strncmp (key, "SigErr", 20) == 0)
      return 1;
   else if (strncmp (key, "SigAdd", 20) == 0)
      return 1;
   else if (strncmp (key, "fix_qtl2_at", 20) == 0)
      return 1;
   else if (strncmp (key, "pos_qtl1", 20) == 0)
      return 1;
   else if (strncmp (key, "pos_qtl2", 20) == 0)
      return 1;
   else
      return 0;
}

int is_twoqtl_parm_int (char *key)
{
   if (strncmp (key, "n_qtl", 20) == 0)
      return 1;
   else if (strncmp (key, "n_batch", 20) == 0)
      return 1;
   else if (strncmp (key, "batch_size", 20) == 0)
      return 1;
   else if (strncmp (key, "fou_sum_MC", 20) == 0)
      return 1;
   else if (strncmp (key, "n_fou_sum_MC", 20) == 0)
      return 1;
   else if (strncmp (key, "ScorIt", 20) == 0)
      return 1;
   else if (strncmp (key, "debug_level", 20) == 0)
      return 1;
   else if (strncmp (key, "null_it", 20) == 0)
      return 1;
   else if (strncmp (key, "l_marker_qtl1", 20) == 0)
      return 1;
   else if (strncmp (key, "l_marker_qtl2", 20) == 0)
      return 1;
   else if (strncmp (key, "gxg_interaction", 20) == 0)
      return 1;
   else
      return 0;
}
